--- xyzspain 



ih735 = {};

function ih735.prerequisitesPresent(specializations)   
return SpecializationUtil.hasSpecialization(Attachable, specializations);
end;
function ih735:load(xmlFile)
            print("'lua loaded '" );
local rotationNode1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotation1#index"));
    if rotationNode1 ~= nil then
        self.rotation1 = {};
        self.rotation1.node = rotationNode1;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation1#minRot"));
        self.rotation1.minRot = {};
        self.rotation1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation1#maxRot"));
        self.rotation1.maxRot = {};
        self.rotation1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation1#rotTime"), 2)*1000;
     
    end;			
local translationPartNode2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.translationPart2#index"));
    if translationPartNode2 ~= nil then
        self.translationPart2 = {};
        self.translationPart2.node = translationPartNode2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart2#minTrans"));
        self.translationPart2.minTrans = {};
        self.translationPart2.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart2.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart2.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart2#maxTrans"));
        self.translationPart2.maxTrans = {};
        self.translationPart2.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart2.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart2.maxTrans[3] = Utils.getNoNil(z, 0);
		
		
	 self.translationPart2.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart2#transTime"), 2)*1000;
        self.translationPart2.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart2#touchTransLimit"), 10);
    end;
  
	local translationPartNode4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.translationPart4#index"));
    if translationPartNode4 ~= nil then
        self.translationPart4 = {};
        self.translationPart4.node = translationPartNode4;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart4#minTrans"));
        self.translationPart4.minTrans = {};
        self.translationPart4.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart4.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart4.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart4#maxTrans"));
        self.translationPart4.maxTrans = {};
        self.translationPart4.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart4.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart4.maxTrans[3] = Utils.getNoNil(z, 0);
		
	
	 self.translationPart4.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart4#transTime"), 4)*1000;
        self.translationPart4.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart4#touchTransLimit"), 10);
    end;
	local translationPartNode5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.translationPart5#index"));
    if translationPartNode5 ~= nil then
        self.translationPart5 = {};
        self.translationPart5.node = translationPartNode5;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart5#minTrans"));
        self.translationPart5.minTrans = {};
        self.translationPart5.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart5.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart5.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart5#maxTrans"));
        self.translationPart5.maxTrans = {};
        self.translationPart5.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart5.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart5.maxTrans[3] = Utils.getNoNil(z, 0);
		
	
		
	 self.translationPart5.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart5#transTime"), 5)*1000;
        self.translationPart5.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart5#touchTransLimit"), 10);
    end;
	local translationPartNode6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.translationPart6#index"));
    if translationPartNode6 ~= nil then
        self.translationPart6 = {};
        self.translationPart6.node = translationPartNode6;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart6#minTrans"));
        self.translationPart6.minTrans = {};
        self.translationPart6.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart6.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart6.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart6#maxTrans"));
        self.translationPart6.maxTrans = {};
        self.translationPart6.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart6.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart6.maxTrans[3] = Utils.getNoNil(z, 0);
		
	
	 self.translationPart6.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart6#transTime"), 6)*1000;
        self.translationPart6.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart6#touchTransLimit"), 10);
    end;
	local translationPartNode7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.translationPart7#index"));
    if translationPartNode7 ~= nil then
        self.translationPart7 = {};
        self.translationPart7.node = translationPartNode7;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart7#minTrans"));
        self.translationPart7.minTrans = {};
        self.translationPart7.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart7.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart7.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart7#maxTrans"));
        self.translationPart7.maxTrans = {};
        self.translationPart7.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart7.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart7.maxTrans[3] = Utils.getNoNil(z, 0);
		
	
	 self.translationPart7.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart7#transTime"), 7)*1000;
        self.translationPart7.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart7#touchTransLimit"), 10);
    end;
	    local numRotParts = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.RotParts#count"), 0);
    self.RotParts = {};
    for i=1, numRotParts do
      local partnamei = string.format("vehicle.RotParts.part" .. "%d", i);
      self.RotParts[i] = {};
      self.RotParts[i].index = Utils.indexToObject(self.components, getXMLString(xmlFile, partnamei .. "#index"));
      local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, partnamei .. "#minRot"));
      self.RotParts[i].minRot = {};
      self.RotParts[i].minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
      self.RotParts[i].minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
      self.RotParts[i].minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
      x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, partnamei .. "#maxRot"));
      self.RotParts[i].maxRot = {};
      self.RotParts[i].maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
      self.RotParts[i].maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
      self.RotParts[i].maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
      self.RotParts[i].rotTime = Utils.getNoNil(getXMLString(xmlFile,  partnamei .. "#rotSpeed"), 2)*1000;
    end;
	self.groundCheck = {};
	self.groundCheck = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.groundCheck#index"));
	
	
end;

function ih735:delete()
end;


function ih735:mouseEvent(posX, posY, isDown, isUp, button)
end;

function ih735:keyEvent(unicode, sym, modifier, isDown)
	if isDown and sym == Input.KEY_b then
		self.translationMax2 = not self.translationMax2;
		-- self.translationMax3 = not self.translationMax3 ;
		self.translationMax4 = not self.translationMax4;
		self.translationMax5 = not self.translationMax5 ;
		self.translationMax6 = not self.translationMax6;
			self.translationMax7 = not self.translationMax7;
		  self.turnOn = not self.turnOn;
		
		  self.rotParts = not self.rotParts;	
	end;
end;


function ih735:update(dt)
if self.attacherVehicle then
	if self.fixAttacher then
			local implement = self.attacherVehicle:getImplementByObject(self);
			if implement ~= nil then
				local joint = self.attacherVehicle.attacherJoints[implement.jointDescIndex];
				self.saveJoint = self.attacherVehicle.attacherJoints[implement.jointDescIndex];
				self.maxRotJoint = joint.maxRotLimit;
				self.attacherJointIndex = implement.jointDescIndex;
				self.rotationCopy  = joint.minRot;
				joint.minRot = {Utils.degToRad(2),0,0};			
				joint.maxRotLimit = {0, 0, 0};
				setJointRotationLimit(joint.jointIndex, 2, true, 0, 0);
			end;
			self.fixAttacher = false;
		end;
end;
local x,y,z = getWorldTranslation(self.groundCheck);
			local terrainHeight = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x, 0, z);
			local gC = y-terrainHeight; 
			  if (math.min(gC) < 0.2) then 
				self.go = true;
				else
				self.go = false;
			  end;
if self.turnOn and self.go and not self.rotParts then
	
			if table.getn(self.cuttingAreas) > 0 then
				local x,y,z = getWorldTranslation(self.cuttingAreas[1].start);
				local x1,y1,z1 = getWorldTranslation(self.cuttingAreas[1].width);
				local x2,y2,z2 = getWorldTranslation(self.cuttingAreas[1].height);
				Utils.updatePloughArea(x, z, x1, z1, x2, z2);
			end;
			end;
	
	local doRotate = self.rotation1max or self.rotation1min 
	if self.rotation1 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation1.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation1.maxRot, self.rotation1.minRot, 3, self.rotation1.rotTime, dt, not self.rotation1max);
        setRotation(self.rotation1.node, unpack(newRot));
    end;
	
		
			if self.translationMax2 ~= nil then
		local x, y, z = getTranslation(self.translationPart2.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart2.maxTrans, self.translationPart2.minTrans, 3, self.translationPart2.transTime, dt, not self.translationMax2);
        setTranslation(self.translationPart2.node, unpack(newTrans));
		end;
	
		if self.translationMax4 ~= nil then
		local x, y, z = getTranslation(self.translationPart4.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart4.maxTrans, self.translationPart4.minTrans, 3, self.translationPart4.transTime, dt,not  self.translationMax4);
        setTranslation(self.translationPart4.node, unpack(newTrans));
		end;	
		if self.translationMax5 ~= nil then
		local x, y, z = getTranslation(self.translationPart5.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart5.maxTrans, self.translationPart5.minTrans, 3, self.translationPart5.transTime, dt, not self.translationMax5);
        setTranslation(self.translationPart5.node, unpack(newTrans));
		end;	
		
		if self.translationMax6 ~= nil then
		local x, y, z = getTranslation(self.translationPart6.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart6.maxTrans, self.translationPart6.minTrans, 3, self.translationPart6.transTime, dt, not self.translationMax6);
        setTranslation(self.translationPart6.node, unpack(newTrans));
		end;	
		if self.translationMax7 ~= nil then
		local x, y, z = getTranslation(self.translationPart7.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart7.maxTrans, self.translationPart7.minTrans, 3, self.translationPart7.transTime, dt, not self.translationMax7);
        setTranslation(self.translationPart7.node, unpack(newTrans));
		end;	
		if self.rotParts ~= nil   then
				for i=1, table.getn(self.RotParts) do
					local rot = {getRotation(self.RotParts[i].index)};
					local newRot = Utils.getMovedLimitedValues(rot, self.RotParts[i].maxRot, self.RotParts[i].minRot, 3, self.RotParts[i].rotTime, dt, not self.rotParts);
					setRotation(self.RotParts[i].index, unpack(newRot));
				end;
				end;	
		
		
		
	local joint = self.componentJoints[2];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[3];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[4];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);

			
			
end;
function ih735:draw()
	
 
end;

function ih735:onAttach()	
		self.translationMax2 = true;
		self.translationMax3 = true ;
		self.translationMax4 = true;
		self.translationMax5 = true ;
		self.translationMax6 =true;
			self.translationMax7 =true;
		
		
		  self.rotParts = true;	
 
	self.fixAttacher = true; 
end;

function ih735:onDetach()
  	self.translationMax2 = false;
		self.translationMax3 = false ;
		self.translationMax4 = false;
		self.translationMax5 = false ;
		self.translationMax6 =false;
			self.translationMax7 =false;
		
		
		  self.rotParts = false;	
 
	
	local joint = self.saveJoint; 
	joint.minRot = self.rotationCopy;
	joint.maxRotLimit = self.maxRotJoint;
end;


